//
//       cvFilter2D()
//
// robocraft.ru
//

#include <cv.h>
#include <highgui.h>
#include <stdlib.h>
#include <stdio.h>

IplImage* image = 0;
IplImage* dst = 0;

int main(int argc, char* argv[])
{
	//     
	char* filename = argc == 2 ? argv[1] : "Image0.jpg";
	//  
	image = cvLoadImage(filename,1);

	printf("[i] image: %s\n", filename);
	assert( image != 0 );

	//   
	dst = cvCloneImage(image);

	//    
	cvNamedWindow("original",CV_WINDOW_AUTOSIZE);
	cvNamedWindow("cvFilter2D",CV_WINDOW_AUTOSIZE);

	float kernel[9];
	kernel[0]=0;
	kernel[1]=0;
	kernel[2]=0;

	kernel[3]=0;
	kernel[4]=1;
	kernel[5]=0;

	kernel[6]=0;
	kernel[7]=0;
	kernel[8]=0;

	// 
	CvMat kernel_matrix=cvMat(3,3,CV_32FC1,kernel);

	//  
	cvFilter2D(image, dst, &kernel_matrix, cvPoint(-1,-1));

	//  
	cvShowImage("original",image);
	cvShowImage("cvFilter2D",dst);

	//   
	cvWaitKey(0);

	//  
	cvReleaseImage(&image);
	cvReleaseImage(&dst);
	//  
	cvDestroyAllWindows();
	return 0;
}
